Subject: RE: Comment on draft-ietf-bmwg-fib-term-00.txt

From: [email-masked]
Date: Fri, 8 Dec 2000 19:27:26 -0700

Hi Gabe,

Thanks for your comment - sorry though that I neglected to reply 'til the
friday before the next meeting.

You raise a good point in your email, however.  After thinking about this, I
think the following algorithm might suffice:

If, as in your example, if we have 10,240 with a distribution of:

[/8, 16%], [/10, 16%], [/19, 16%], [/22, 16%], [/23 16%], [/24, 16%], [/29,
4%]

The number of routes per prefix works out to be:

1638.40 /8 Routes
1638.40 /10 Routes
1638.40 /19 Routes
1638.40 /22 Routes
1638.40 /23 Routes
1638.40 /24 Routes
409.60 /29 Routes

Round down the number of route for each prefix length, and add up the
fractional portions:

1638 /8 Routes
1638 /10 Routes
1638 /19 Routes
1638 /22 Routes
1638 /23 Routes
1638 /24 Routes
409 /29 Routes

And a remainder of 3 routes (BTW, this will always be a whole number, and
will be less than the total number of prefix lengths [in this case, 7]).

Now, the most important thing is to remember that we need to advertise
10,240 routes into the router.  What I think we should do is to take the
remaining 3 routes and add a single route to each of the largest number of
prefixes (i.e. we'll add a route to the /8, a route to the /10 and a route
to the /19).  So, our distribution ends up to be:

1639 /8 Routes
1639 /10 Routes
1639 /19 Routes
1638 /22 Routes
1638 /23 Routes
1638 /24 Routes
409 /29 Routes

What do you think?

Guy

> -----Original Message-----
> From: Gabe Heininger [mailto:[email-masked]]
> Sent: November 7, 2000 3:16 PM
> To: [email-masked]
> Subject: Comment on draft-ietf-bmwg-fib-term-00.txt
> 
> 
> Guy,
> 
>    Section 5.6 FIB Prefix Distribution
> 
>    Overall this section is complete. But there is one issue 
> with your selection
> of Measurement Units.
>    In a situation where we are calculating Prefix 
> Distribution for an existing
> FIB, this will suffice. However, if we were trying to build a FIB (for
> benchmarking purposes of course) to match a given Prefix 
> Distribution specified
> in this format, due to the math involved and the chosen 
> inputs we can end up
> with a fractional route. These must be accounted for. This is 
> best illustrated
> by example:
> 
> Build the following routing table:
> 
> 10,240 Routes
> [/8, 16%], [/10, 16%], [/19, 16%], [/22, 16%], [/23 16%], 
> [/24, 16%], [/29, 4%]
> 
> 1638.40 /8 Routes
> 1638.40 /10 Routes
> 1638.40 /19 Routes
> 1638.40 /22 Routes
> 1638.40 /23 Routes
> 1638.40 /24 Routes
> 409.60 /29 Routes
> 
> Using standard rounding, total number of routes = 10,238. If 
> we are testing BGP
> aggregation, or if a stream of traffic is configured to all 
> destination
> networks, it is possible that two networks would be missing 
> (in the given
> example), possibly invalidating the test. How do we account 
> for the missing
> routes when specifying prefix distribution in this fashion?
> 
> Gabe Heininger
> Senior Engineer
> Ixia
> 
> 
>